import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * class Mobs
 * 
 * @author Alberto Milan
 * @version 1.0v
 */
public class Mobs  extends Actor
{
    final static double WALKING_SPEED = 0.5;
    final static int DER=0;
    final static int IZQ=1;
    final static int ARR=2;
    final static int ABA=3;
   /**
    * Act method
    */
    public void act()
    {
    }
     /**
     * Method to move 1 cell right the Spiders
     */
    public void moveRight()
    {

        int x = getX();
        int y = getY();

        if(getX() < 43 && canMove(DER)){
                setLocation(x+=1, y);
                if(canSee(Pinguen.class)){
                    List act = getWorld().getObjectsAt(getX(), getY(),Pinguen.class);
                    ((Pinguen)act.get(0)).setKill(true);
                   }
                }        
    }
    /**
     * Method to move 1 cell lefy the Spiders
     */
    public void moveLeft()
    {
        int x = getX();
        int y = getY();
        
        if(getX() > 1  && canMove(IZQ)){
                setLocation(x-=1, y);
                if(canSee(Pinguen.class)){
                    List act = getWorld().getObjectsAt(getX(), getY(),Pinguen.class);
                    ((Pinguen)act.get(0)).setKill(true);
                   }
                }
    }
    /**
     * Method to move 1 cell up the Spiders
     */
    public void moveUp()
    {
        int x = getX();
        int y = getY();
        if(getY() > 1 && canMove(ARR)){
                setLocation(x, y-=1);
                if(canSee(Pinguen.class)){
                    List act = getWorld().getObjectsAt(getX(), getY(),Pinguen.class);
                    ((Pinguen)act.get(0)).setKill(true);
                   }
            }
    }
    /**
     * Method to move 1 cell down the Spiders
     */
    public void moveDown()
    {

        int x = getX();
        int y = getY();
        if(getY() < 29 && canMove(ABA))
                setLocation(x, y+=1);
                if(canSee(Pinguen.class)){
                    List act = getWorld().getObjectsAt(getX(), getY(),Pinguen.class);
                    ((Pinguen)act.get(0)).setKill(true);
                   }

     }
  
    /**
     * @param clss class type
     * @return true if we can see an object of class 'clss' right where we are. 
     * False if there is no such object here.
     * 
     */
    public boolean canSee(Class clss)
    {
        int mX= this.getX(), mY=this.getY();
        int pX, pY;
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        if(actor != null){
            pX=actor.getX();
            pY=actor.getY();
            if(((pX == mX)||(pX == mX+1)||(pX == mX-1)) && ((pY == mY)||(pY == mY+1)||(pY == mY-1)))
                return true;
            }
        return false;        
    }
     /**
     * Check if an object type block it's in the way
     * @retur true if is, false isn't
     */
    public Class isBlock()
    {
        return getOneIntersectingObject(Block.class) != null ? getOneIntersectingObject(Block.class).getClass() : null;
    }
    /**
     * Check if the character can move in some direction
     * @param dir to check if can move
     * @retur true if is, false isn't
     */
    public boolean canMove(int dir)
    {
        World myWorld = getWorld();
        int x = 0,y = 0;
        switch(dir){
            case DER :  x = getX()+1;
                        y = getY();  
                        break;
            case IZQ :  x = getX()-1;
                        y = getY();
                        break;
            case ARR :  x = getX();
                        y = getY()-1;
                        break;
            case ABA :  x = getX();
                        y = getY()+1;
         }
        
        List obstacle = myWorld.getObjectsAt(x, y, Block.class);
        if(obstacle.isEmpty()) { 
            return true;
        }
        else {
            return false;
        }
        
    }
    /**
     * Method to move 1 cell right the Birdy
     */
    public void moveRightB()
    {

        int x = getX();
        int y = getY();
        int z = Greenfoot.getRandomNumber(2);
        if(getX() < 43){
                if(z==0)
                setLocation(x+=1, y+=1);
                else
                setLocation(x+=1, y-=1);
                if(canSee(Pinguen.class)){
                    //((Pinguen)getWorld().getObjectsAt(getX(), getY(),Pinguen.class)).setKill(true);
                    List act = getWorld().getObjectsAt(getX(), getY(),Pinguen.class);
                    ((Pinguen)act.get(0)).setKill(true);
                   }
                }       
    }
    /**
     * Method to move 1 cell left the Birdy
     */
    public void moveLeftB()
    {
        int x = getX();
        int y = getY();
        int z = Greenfoot.getRandomNumber(2);
        if(getX() > 1){
                if(z==0)
                setLocation(x-=1, y+=1);
                else
                setLocation(x-=1, y-=1);
                if(canSee(Pinguen.class)){
                    List act = getWorld().getObjectsAt(getX(), getY(),Pinguen.class);
                    ((Pinguen)act.get(0)).setKill(true);
                    }
                }
    }
    /**
     * Method to move 1 cell up the Birdy
     */
    public void moveUpB()
    {
        int x = getX();
        int y = getY();
        int z = Greenfoot.getRandomNumber(2);
        if(getY() > 1){
                if(z==0)
                setLocation(x-=1, y-=1);
                else
                setLocation(x+=1, y-=1);
                if(canSee(Pinguen.class)){
                    List act = getWorld().getObjectsAt(getX(), getY(),Pinguen.class);
                    ((Pinguen)act.get(0)).setKill(true);
                   }
            }
    }
    /**
     * Method to move 1 cell down the Birdy
     */
    public void moveDownB()
    {

        int x = getX();
        int y = getY();
        int z = Greenfoot.getRandomNumber(2);
        if(getY() < 29)
                if(z==0)
                setLocation(x+=1, y+=1);
                else
                setLocation(x-=1, y+=1);
                if(canSee(Pinguen.class)){
                    List act = getWorld().getObjectsAt(getX(), getY(),Pinguen.class);
                    ((Pinguen)act.get(0)).setKill(true);               
                   }

     }
 }
