import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Class with all the methods from the penguins
 * 
 * @Alberto Milan
 * @v1.0
 */
public class Pinguen  extends Actor
{
    private static final double WALKING_SPEED = 0.8;    
    final static int DER=0;
    final static int IZQ=1;
    final static int ARR=2;
    final static int ABA=3;
    protected boolean kill;   
    protected boolean Catch;
    private List time;
    
    /**
     * Constructor, start values
     */
    public Pinguen()
    {
        Catch = false;
        kill = false;
    }

    /**
     * constantly check the time of game, if is 0, kill the player
     */
    public void act()
    {      
        time = getWorld().getObjects(Time.class);
        if(time != null)
            if(((Time)time.get(0)).timeOut())
                kill = true;
    }
    /**
     * Method to move 1 cell right the penguins
     */
    public void moveRight()
    {
        int x = getX();
        int y = getY();

        if(getX() < 43 && canMove(DER) && !Catch){
                setLocation(x+=1, y);
                if(canSee(SpiderWeb.class))
                    Catch = true;
                else
                    Catch = false;
                }else{ 
                    if(isBlock() == IceCube.class)
                        Greenfoot.playSound("ice_click.wav");
                    if(!canSee(SpiderWeb.class))
                            Catch = false;
                }
    }
    /**
     * Method to move 1 cell left the penguins
     */
    public void moveLeft()
    {
        int x = getX();
        int y = getY();
        
        if(getX() > 1  && canMove(IZQ) && !Catch){
                setLocation(x-=1, y);
                if(canSee(SpiderWeb.class))
                    Catch = true;
                else
                    Catch = false;
                }else{ 
                    if(isBlock() == IceCube.class)
                        Greenfoot.playSound("ice_click.wav");
                    if(!canSee(SpiderWeb.class))
                            Catch = false;
                }
            
    }
    /**
     * Method to move 1 cell up the penguins
     */
    public void moveUp()
    {
        int x = getX();
        int y = getY();
        if(getY() > 1 && canMove(ARR) && !Catch){
                setLocation(x, y-=1);
                if(canSee(SpiderWeb.class))
                    Catch = true;
                else
                    Catch = false;
                }else{
                    if(!canSee(SpiderWeb.class))
                            Catch = false;
                    if(isBlock() == IceCube.class)
                        Greenfoot.playSound("ice_click.wav");
                }
            

    }
    /**
     * Method to move 1 cell right the penguins
     */
    public void moveDown()
    {

        int x = getX();
        int y = getY();
        if(getY() < 29 && canMove(ABA) && !Catch){
                setLocation(x, y+=1);
                if(canSee(SpiderWeb.class))
                    Catch = true;
                else
                    Catch = false;
                }else{ 
                    if(isBlock() == IceCube.class)
                        Greenfoot.playSound("ice_click.wav");
                    if(!canSee(SpiderWeb.class))
                            Catch = false;
                }
     }    
     /**
     * If a object it on see range
     * @return true if is, false isn't
     */
    public boolean canSee(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;        
    }
     /**
     * Try to eat an object of class 'clss'. This is only successful if there
     * is such an object where we currently are. Otherwise this method does
     * nothing.
     * @param clss type to eat
     */
    public void eat(Class clss)
    {
        Actor actor = getOneObjectAtOffset(3, 0, clss);
        if(actor != null) {
            getWorld().removeObject(actor);
        }
    }
    /**
     * Check if an object type block it's in the way
     * @retur true if is, false isn't
     */
    public Class isBlock()
    {
        return getOneIntersectingObject(Block.class) != null ? getOneIntersectingObject(Block.class).getClass() : null;
    }
    /**
     * Check if the character can move in some direction
     * @param dir to check if can move
     * @retur true if is, false isn't
     */
    public boolean canMove(int dir)
    {
        World myWorld = getWorld();
        int x = 0,y = 0;
        switch(dir){
            case DER :  x = getX()+1;
                        y = getY();  
                        break;
            case IZQ :  x = getX()-1;
                        y = getY();
                        break;
            case ARR :  x = getX();
                        y = getY()-1;
                        break;
            case ABA :  x = getX();
                        y = getY()+1;
         }
        
        List obstacle = myWorld.getObjectsAt(x, y, Block.class);
        if(obstacle.isEmpty()) { 
            return true;
        }
        else {
            return false;
        }
    }
    /**
     * Change the kill status of the penguins
     * @param newStat true or false
     */
    public void setKill(boolean newStat)
    {
        kill = newStat;
    }

        
}