import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;
import java.util.Calendar;

/**
 * class Tablet
 * 
 * @author Alberto Milan
 * @version 1.0v
 */
public class Tablet  extends Score
{
    public static final float FONT_SIZE = 48.0f;
    public static final int WIDTH = 500;
    public static final int HEIGHT = 300;
    /**
     * Constructor that  call the other constructor to initialize in 100 te score
     */
    public Tablet()
    {
        this(100);
    }
    /**
     * Constructor that make the tablet with the scores
     * @param score in the game
     */
    public Tablet(int score)
    {
        makeImage("Game Finished", "Score: ", score);
    }
    /**
     * method to draw the tablet
     * @param title for the tablet
     * @param prefix for the numbers
     * @param score of the game
     */
    private void makeImage(String title, String prefix, int score)
    {
        GreenfootImage image = new GreenfootImage(WIDTH, HEIGHT);

        image.setColor(new Color(155,255,255, 128));
        image.fillRect(0, 0, WIDTH, HEIGHT);
        image.setColor(new Color(0, 0, 0, 128));
        image.fillRect(5, 5, WIDTH-10, HEIGHT-10);
        Font font = image.getFont();
        font = font.deriveFont(FONT_SIZE);
        image.setFont(font);
        image.setColor(Color.WHITE);
        image.drawString(title, 60, 100);
        image.drawString(prefix + score, 60, 200);
        setImage(image);
    }
}
