import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.Calendar;
import java.awt.Font;
import java.awt.Color;
/**
 * class Time
 * 
 * @author Alberto Milan
 * @version 1.0v
 */
public class Time  extends Info
{
    private String seconds;
    private int sec = 91;
    private int compare = 0;
    /**
     * Act method, update and repaints the time
     */
    public void act() 
    {
        updateTime();
        draw();
    }
    /**
     * Method that take the info of system to update the time
     */ 
    private void updateTime()
    {
        Calendar calendar = Calendar.getInstance();
        int seconds = calendar.get(Calendar.SECOND);
        //int sec = 0;
        if(compare != seconds){
            compare = seconds;
            if(this.sec > 0)
              this.sec--;
        }
        this.seconds = getStr(this.sec);
    }
    /**
     * Put a 0 before the number if it's less than 10.
     */
    private String getStr(int val)
    {
        String str = null;
        if(val > 59){
            if(val<70) {
            str = "01:0"+(val-60);
        }
        else {
             str = "01:"+(val-60);
        }    
        }else{
        if(val<10) {
            str = "00:0"+val;
        }
        else {

             str = "00:"+val;
        }}
        return str;
    }
     /**
     * Draw the rectangle with the time
     */
    private void draw()
    {
        GreenfootImage image = new GreenfootImage(50,40);
        Font font = image.getFont();
        font = font.deriveFont(new Float(19));
        font = font.deriveFont(Font.ITALIC);
        font = font.deriveFont(Font.BOLD);
        image.setFont(font);
        image.setColor(Color.BLUE);
        image.drawString("" + seconds, 0, 20);
        setImage(image);
    }
    /**
     * Method to consult if the time is zero
     * @return true if it's, false if isn't
     */
    public boolean timeOut()
    {
        return sec == 0 ? true : false;
    }
    /**
     * Add time to the clock
     * @param t time to add
     */
    public void raiseTime(int t)
    {
        sec+=t;
    }
}
